//Socket handling. -Barghest

//#include <string>
#include "legend.h"
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/telnet.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <cstring>
//using namespace std;

const int MUDPORT = 5460; 	//Port that the MUD will run on. 
							//Set to the port your host or service provider
							//has set for you to run on.



//void log_console(string logstring);

namespace SOCKET
{
	
	class Psocket_Data;
	
class Socket_Handler
{
	private:
	int sock_main;
//	Psocket_Data *first_psocket;
//	Psocket_Data *last_psocket;
	vector<Psocket_Data> psock_vector;
	int max_fd;
	fd_set master_set, working_set;
	
	public:
	Socket_Handler(); //Defined in socket.cpp
	~Socket_Handler(); //Defined in socket.cpp
	void set_main(int newmain) {sock_main = newmain;}
	int get_main(void) {return sock_main;}
//	void set_first_socket(Psocket_Data *newfirst) {first_psocket = newfirst;}
//	Psocket_Data *get_first_socket(void) const {return first_psocket;}
//	void set_last_socket(Psocket_Data *newlast) {last_psocket = newlast;}
//	Psocket_Data *get_last_socket(void) const {return last_psocket;}
	int init_socket(void); //Defined in socket.cpp
	void link_psocket(Psocket_Data *psock_new); //Defined in socket.cpp
	void unlink_psocket(const unsigned int vectorpos); //Defined in socket.cpp
	//TODO: Define
	void set_max_fd(void); //Set the max FD by going through the socket set.
	void set_max_fd(int fd_new) {max_fd = fd_new;} //Set the max_fd directly.
	int get_max_fd(void) const {return max_fd;}
	int get_select_fd(void) const {return (max_fd+1);} //Return the proper argument to select().
	void zero_sets(void) {FD_ZERO(&master_set); FD_ZERO(&working_set);}
	void add_socket(int sockfd) {FD_SET(sockfd, &master_set);}
	void sync_sets(void) {working_set = master_set;}
	fd_set *get_master_set(void) {return &master_set;}
	fd_set *get_working_set(void) {return &working_set;}
	int get_max_vector(void) const; //Defined in socket.cpp
	void receive_input(int sockfd); //Defined in socket.cpp
	void close_socket(int sockfd); //Defined in socket.cpp
};

class Psocket_Data
{
	protected:
	socklen_t ip_addr;
	int sock_fd;
	int vectorpos;
	Psocket_Data *next;
	Psocket_Data *prev;
	
	public:
	Psocket_Data() {} //TODO: Define. This should not happen and should throw an exception if it does.
	~Psocket_Data() {}
	Psocket_Data(const socklen_t ip, const unsigned int sock, const unsigned int vectorpos);  //TODO: Add error checking.
	int get_ip(void) const {return ip_addr;}
	const void set_next(Psocket_Data *set) {next = set;}
	Psocket_Data *get_next(void) const {return next;}
	const void set_prev(Psocket_Data *set) {prev = set;}
	Psocket_Data *get_prev(void) const {return prev;}
	int get_vectorpos(void) const {return vectorpos;}
	void set_vectorpos(int newvector) {vectorpos = newvector;}
	int get_sockfd(void) const {return sock_fd;}
	void set_sockfd(int new_fd) {sock_fd = new_fd;}
};

}//end namespace SOCKET
